#include <Adafruit_NeoPixel.h>

#define PIN D0

#define NUMPIXELS 1

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

#include <BLEDevice.h>
#include <BLEUtils.h>
#include <BLEServer.h>

// See the following for generating UUIDs:
// https://www.uuidgenerator.net/

#define SERVICE_UUID "34bb9231-b661-49ed-9c9e-94664503c001"
#define CHARACTERISTIC_UUID "beb5483e-36e1-4688-b7f5-ea07361b26a8"

class MyCallbacks : public BLECharacteristicCallbacks {
  void onWrite(BLECharacteristic *pCharacteristic) {

    String value = pCharacteristic->getValue();

    if (value.length() > 0) {
      String control = String(value.c_str());
      if (control == "On") {
        Serial.println(control);
        pixels.setPixelColor(0, pixels.Color(0, 0, 150));  // Blue
        pixels.show();                                     // Send the updated pixel colors to the hardware.
        delay(10);
      } else if (control == "Off") {
        Serial.println(control);
        pixels.clear();
        pixels.show();
        delay(10);
      } else {
        Serial.println("Error");
      }
    }
  }
};

void setup() {
  pixels.begin();  // INITIALIZE NeoPixel strip object (REQUIRED)
  pixels.clear();
  pixels.show();

  Serial.begin(115200);

  BLEDevice::init("FabAcademyESP");
  BLEServer *pServer = BLEDevice::createServer();

  BLEService *pService = pServer->createService(SERVICE_UUID);

  BLECharacteristic *pCharacteristic = pService->createCharacteristic(
    CHARACTERISTIC_UUID,
    BLECharacteristic::PROPERTY_READ | BLECharacteristic::PROPERTY_WRITE);

  pCharacteristic->setCallbacks(new MyCallbacks());

  pCharacteristic->setValue("Hello World");
  pService->start();

  BLEAdvertising *pAdvertising = pServer->getAdvertising();
  pAdvertising->start();
}

void loop() {
}
